﻿local ADDON_PREFIX    = "LGAADDON";
local RECEIVER_PREFIX = "LGRADDON";

local version     = "8.0.11";

local rolling     = false;
local rolled      = false;
local acceptOnes  = false;
local autojoin    = false;
local updated     = false;
local textchannel = "RAID";
local current     = 0;

-- LOAD FUNCTION --
function LGReceiver_OnLoad(this)
	DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffff8900<Lumpensammler Gambler Receiver v%s>|cffffff00 loaded. Type /lgr to use.", version));

	this:RegisterEvent("CHAT_MSG_RAID");
	this:RegisterEvent("CHAT_MSG_RAID_LEADER");
	this:RegisterEvent("CHAT_MSG_PARTY");
	this:RegisterEvent("CHAT_MSG_PARTY_LEADER");
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("CHAT_MSG_ADDON");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterForDrag("LeftButton");
	C_ChatInfo.RegisterAddonMessagePrefix(ADDON_PREFIX);
	
	autojoin = false;
	LGReceiver_AUTOJOIN_Button:SetText("Autojoin");
	LGReceiver_ROLL_Button:Disable();
	LGReceiver_Frame:Hide();
	
end

function LGReceiver_OnEvent(self, event, ...)

	-- LOADS ALL DATA FOR INITIALIZATION OF ADDON --
	local arg1, arg2 = ...;
	if (event == "PLAYER_LOGIN") then
		LGReceiver_EditBox:SetJustifyH("CENTER");
		LGReceiver_EditBox2:SetJustifyH("CENTER");

		if(not LGReceiver) then
			LGReceiver = {
				["active"] = 1,
				["max"] = 10000,
				["working"] = 1
			}
		end
		if(not LGReceiver["stats"]) then LGReceiver["stats"] = 0; end
		if(not LGReceiver["active"]) then LGReceiver["active"] = 1; end
		if(not LGReceiver["max"]) then LGReceiver["max"] = 10000; end
		if(not LGReceiver["working"]) then LGReceiver["working"] = 1; end
		if(not LGReceiver["transactionLog"]) then LGReceiver["transactionLog"] = { }; end
		if(not LGReceiver["transactions"]) then LGReceiver["transactions"] = { }; end
		if(not LGReceiver["button"]) then LGReceiver["button"] = 1; end
		if(not LGReceiver["popup"]) then LGReceiver["popup"] = 1; end

		LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
		
		if(current == nil or current == "") then current = 0; end
		LGReceiver_EditBox2:SetText(""..current);
		-- create/reset current transaction table 
		LGReceiver["current"] = { };

		if(LGReceiver["active"] == 1) then
			LGReceiver_Frame:Show();
		else
			LGReceiver_Frame:Hide();
		end

		if(LGReceiver["button"] == 1) then
			LGReceiver_Button:Show();
		else
			LGReceiver_Button:Hide();
		end
		
		if(LGReceiver["working"] == 1) then
			LGReceiver_ACTIVE_Button:SetText("Activated");
		else
			LGReceiver_UPDATE_Button:Disable();
			LGReceiver_AUTOJOIN_Button:Disable();
			LGReceiver_AUTOJOIN_Button:SetText("Autojoin");
			autojoin = false;
			LGReceiver_ACTIVE_Button:SetText("Deactivated");
		end
		
		LGReceiver_ROLL_Button:Disable();
		
	end
	
	if (acceptOnes == true) then
		if (event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_PARTY_LEADER" or event == "CHAT_MSG_PARTY") then
			local help_arg = arg2;
			local junk_arg;
			help_arg, junk_arg = strsplit("-", arg2);
			if(arg1 == "1" and help_arg == UnitName("player")) then
				rolling = true;
				acceptOnes = false;
				LGReceiver_ROLL_Button:Disable();
			end
		end
	end

	if (rolled == true and event == "CHAT_MSG_SYSTEM" and LGReceiver["popup"] == 1) then
		local temp1 = tostring(arg1);
		local player, junk, junk2, roll, range = strsplit(" ", temp1);

		if junk == "würfelt." and player == UnitName("player") then
			local minRoll, maxRoll = strsplit("-",range);
			maxRoll = tonumber(strsub(maxRoll,1,-2));
			StaticPopupDialogs["Rolled"] = {
				text = "\n"..BreakUpLargeNumbers(roll).." / "..BreakUpLargeNumbers(maxRoll),
				timeout = 3,
				whileDead = true,
				hideOnEscape = true,
				preferredIndex = 3,
			}

			StaticPopup_Show ("Rolled");

			rolled = false;
		end	
	
	elseif (event == "CHAT_MSG_ADDON" and LGReceiver["working"] == 1) then
		local prefix, message, channel, sender = ...;
		local msgPrefix, msg1, msg2 = strsplit("\t", message);

		if(prefix == ADDON_PREFIX) then
			if(msgPrefix == "queryRoll") then
				textchannel = channel;
				local help_message = tonumber(msg1);
				local help_max = tonumber(LGReceiver["max"]);
				FlashClientIcon();
				if(autojoin == true and help_message <= help_max) then
					LGReceiver_OnClickROLL();
				else
					LGReceiver_ROLL_Button:Enable();
					acceptOnes = true;
				end

			elseif(msgPrefix == "executeRoll") then
				rolled = true;
				if(rolling == true) then
					RandomRoll(1, msg1);
				end
				acceptOnes = false;
				rolling = false;
				LGReceiver_ROLL_Button:Disable();

			elseif(msgPrefix == "tiebreak") then
				RandomRoll(1, msg1);

			elseif(msgPrefix == "rollWon") then
				local player1, player2 = strsplit(":", msg1);
				if(player1 == UnitName("player")) then
					LGReceiver["stats"] = LGReceiver["stats"] + msg2;
					current = current + msg2;
					LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
					LGReceiver_EditBox2:SetText(""..current);

					LGReceiver_FillLogs(player2, msg2, true);
				end
			
			elseif(msgPrefix == "rollLost") then
				local player1, player2 = strsplit(":", msg1);
				if(player1 == UnitName("player")) then
					LGReceiver["stats"] = LGReceiver["stats"] - msg2;
					current = current - msg2;
					LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
					LGReceiver_EditBox2:SetText(""..current);

					LGReceiver_FillLogs(player2, msg2, false);
				end

			elseif(msgPrefix == "updateWin") then
				LGReceiver["stats"] = msg1;
				LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
				updated = true;
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LGR] has been updated.");

			elseif(msgPrefix == "updateLoss") then
				local help = (0 - msg1) ;
				LGReceiver["stats"] = help;
				LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
				updated = true;
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LGR] has been updated.");

			elseif(msgPrefix == "updateFailed") then
				updated = true;
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LG] |cffff8900No stats yet with this character!!");

			elseif(msgPrefix == "reset") then
				acceptOnes = false;
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LG] |cffff8900Current game has been reset!");
				rolling = false;
				rolled  = false;
				LGReceiver_ROLL_Button:Disable();

			elseif(msgPrefix == "pointless") then
				LGReceiver_OnClickPOINTLESS();

			elseif(msgPrefix == "installed") then
				C_ChatInfo.SendAddonMessage(RECEIVER_PREFIX, "installed", "GUILD");

			elseif(msgPrefix == "open") then
				LGReceiver_Frame:Show();
				LGReceiver["active"] = 1;
			
			elseif(msgPrefix == "message") then
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LG] |cffff8900" .. msg1);
			end
		end
	
	elseif (event == "CHAT_MSG_ADDON" and LGReceiver["working"] == 0) then
		local prefix, message, channel, sender = ...;
		local msgPrefix, msg1, msg2 = strsplit("\t", message);
	
		if(prefix == ADDON_PREFIX) then
			if(msgPrefix == "rollWon") then
				local player1, player2 = strsplit(":", msg1);
				if(player1 == UnitName("player")) then
					LGReceiver["stats"] = LGReceiver["stats"] + msg2;
					current = current + msg2;
					LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
					LGReceiver_EditBox2:SetText(""..current);

					LGReceiver_FillLogs(player2, msg2, true);
				end
			
			elseif(msgPrefix == "rollLost") then
				local player1, player2 = strsplit(":", msg1);
				if(player1 == UnitName("player")) then
					LGReceiver["stats"] = LGReceiver["stats"] - msg2;
					current = current - msg2;
					LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
					LGReceiver_EditBox2:SetText(""..current);

					LGReceiver_FillLogs(player2, msg2, false);
				end

			elseif(msgPrefix == "pointless") then
				LGReceiver_OnClickPOINTLESS();

			elseif(msgPrefix == "installed") then
				C_ChatInfo.SendAddonMessage(RECEIVER_PREFIX, "installed", "GUILD");
			
			elseif(msgPrefix == "message") then
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LG] |cffff8900" .. msg1);
			end
		end
	end
end

function LGReceiver_EditBox_OnTextChanged()
	LGReceiver_EditBox:ClearFocus();
	LGReceiver_EditBox:SetText(""..LGReceiver["stats"]);
end

function LGReceiver_EditBox2_OnTextChanged()
	LGReceiver_EditBox2:ClearFocus();
	LGReceiver_EditBox2:SetText(""..current);
end

function LGReceiver_OnClickUPDATE()
	updated = false;
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LGR] is trying to update.");
	if(IsInRaid()) then
		C_ChatInfo.SendAddonMessage(RECEIVER_PREFIX, "update", "RAID");
	else
		C_ChatInfo.SendAddonMessage(RECEIVER_PREFIX, "update", "GUILD");
	end

	C_Timer.After(3, 
		function()
			if(updated == false) then
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000[LGR] failed to update!");
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Main [LG] Addon is not online in guild or raid at the moment!");
			end
		end);

	LGReceiver_EditBox:ClearFocus();
	LGReceiver_EditBox2:ClearFocus();
end

function LGReceiver_OnClickROLL()
	rolling = true;
	acceptOnes = false;
	SendChatMessage("1", textchannel, GetDefaultLanguage("player"));
	LGReceiver_ROLL_Button:Disable();
end

function LGReceiver_OnClickAUTOJOIN()

	if(autojoin == nil) then autojoin = false; end

	if(autojoin == true) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LGR] Autojoin (off)");
		LGReceiver_AUTOJOIN_Button:SetText("Autojoin");
		autojoin = false;
	else
		LGReceiver_AUTOJOIN_Button:SetText("|cffff0000Autojoin (on)");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LGR] Autojoin (on) |cffff0000Use with care!!");
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00[LGR] |cff009EFFAutojoin maximum = '%s'", LGReceiver["max"]));
		autojoin = true;
		if(acceptOnes == true) then
			LGReceiver_OnClickROLL();
		end
	end

end

function LGReceiver_OnClickPOINTLESS()
	SendChatMessage("Ich bin ein Noob!!", "GUILD", GetDefaultLanguage("player"));
end

function LGReceiver_OnClickACTIVE()

	if(LGReceiver["working"] == nil) then LGReceiver["working"] = 1; end
	
	if(LGReceiver["working"] == 0) then
		LGReceiver_UPDATE_Button:Enable();
		LGReceiver_AUTOJOIN_Button:Enable();
		LGReceiver_ACTIVE_Button:SetText("Activated");
		LGReceiver["working"] = 1;
	else
		LGReceiver_UPDATE_Button:Disable();
		LGReceiver_AUTOJOIN_Button:Disable();
		LGReceiver_ROLL_Button:Disable();
		LGReceiver_AUTOJOIN_Button:SetText("Autojoin");
		autojoin = false;
		LGReceiver_ACTIVE_Button:SetText("Deactivated");
		LGReceiver["working"] = 0;
	end

end

function LGReceiver_FillLogs(player, gold, won)
	if(not LGReceiver["transactions"][player]) then LGReceiver["transactions"][player] = 0; end
	if(not LGReceiver["current"][player]) then LGReceiver["current"][player] = 0; end

	-- won true = positive | won false = negative
	if(won) then
		LGReceiver["transactionLog"][GetServerTime()] = "WON "..BreakUpLargeNumbers(gold).." gold from "..player;
		LGReceiver["transactions"][player] = LGReceiver["transactions"][player] + gold;
		LGReceiver["current"][player] = LGReceiver["current"][player] + gold;
		StaticPopupDialogs["Notification"] = {
			text = "You WON from "..player.."\n",
			timeout = 5,
			whileDead = true,
			hideOnEscape = true,
			preferredIndex = 3,
			hasMoneyFrame = true,
			OnShow = function(self)
				MoneyFrame_Update(self.moneyFrame, gold * 10000);
			end,
		}
	else
		LGReceiver["transactionLog"][GetServerTime()] = "LOST "..BreakUpLargeNumbers(gold).." gold to "..player;
		LGReceiver["transactions"][player] = LGReceiver["transactions"][player] - gold;
		LGReceiver["current"][player] = LGReceiver["current"][player] - gold;
		StaticPopupDialogs["Notification"] = {
			text = "You LOST to "..player.."\n",
			timeout = 5,
			whileDead = true,
			hideOnEscape = true,
			preferredIndex = 3,
			hasMoneyFrame = true,
			OnShow = function(self)
				MoneyFrame_Update(self.moneyFrame, gold * 10000);
			end,
		}
	end

	StaticPopup_Show ("Notification");
end

function LGReceiver_ResetLogs()
	LGReceiver["transactionLog"] = { };
	LGReceiver["transactions"] = { };

	DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Logs have been reset!");
end

function LGReceiver_ShowTransactionLog()

	if (next(LGReceiver["transactionLog"]) == nil) then
	  DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00No data in total log!");
	  return;
	end

	DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Total log:");

	local tkeys = {}

	for k in pairs(LGReceiver["transactionLog"]) do 
		table.insert(tkeys, k);
	end

	-- table.sort(tkeys, function(a, b) return a > b end) => DESC
	table.sort(tkeys);

	for _, k in ipairs(tkeys) do 
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffffff"..date("%d.%m.%y %H:%M:%S", k).." |cffffff00You "..LGReceiver["transactionLog"][k]); 
	end

	DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Total log (players):");

	tkeys = {};

	for k in pairs(LGReceiver["transactions"]) do 
		table.insert(tkeys, k);
	end

	table.sort(tkeys);

	for _, k in ipairs(tkeys) do 
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00"..k.." => "..BreakUpLargeNumbers(LGReceiver["transactions"][k]).." gold");
	end

end

function LGReceiver_ShowCurrentLog()

	if (next(LGReceiver["current"]) == nil) then
	  DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00No data in current log!");
	  return;
	end

	DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Current log (players):");

	local tkeys = {}

	for k in pairs(LGReceiver["current"]) do 
		table.insert(tkeys, k);
	end

	table.sort(tkeys);

	for _, k in ipairs(tkeys) do 
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00"..k.." => "..BreakUpLargeNumbers(LGReceiver["current"][k]).." gold");
	end
end

function LGReceiver_RevertPosition()
	LGReceiver_Frame:ClearAllPoints()
	LGReceiver_Button:ClearAllPoints();
	LGReceiver_Frame:SetPoint("CENTER", UIParent);
	LGReceiver_Button:SetPoint("CENTER", UIParent);
	LGReceiver_Frame:Show();
	LGReceiver["active"] = 1;
	LGReceiver_Button:Show();
	LGReceiver["button"] = 1;
end

function LGReceiver_EditBox_OnLoad()
	LGReceiver_EditBox:SetNumeric(false);
	LGReceiver_EditBox:SetAutoFocus(false);
end

function LGReceiver_EditBox2_OnLoad()
	LGReceiver_EditBox2:SetNumeric(false);
	LGReceiver_EditBox2:SetAutoFocus(false);
end

function LGReceiver_Hide()
	LGReceiver_Frame:Hide();
	LGReceiver["active"] = 0;
end

function LGReceiver_Toggle()
	if(LGReceiver["active"] == 0) then
		LGReceiver_Frame:Show();
		LGReceiver["active"] = 1;
	else
		LGReceiver_Frame:Hide();
		LGReceiver["active"] = 0;
	end
end

function LGReceiver_ToggleButton()
	if(LGReceiver["button"] == 0) then
		LGReceiver_Button:Show();
		LGReceiver["button"] = 1;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Show button");
	else
		LGReceiver_Button:Hide();
		LGReceiver["button"] = 0;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Hide button");
	end
end

function LGReceiver_TogglePopups()
	if(LGReceiver["popup"] == 0) then
		LGReceiver["popup"] = 1;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Show popups");
	else
		LGReceiver["popup"] = 0;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900[LGR] |cffffff00Hide popups");
	end
end

function LGReceiver_Button_OnClick(button)
	if(button == "LeftButton") then
		LGReceiver_Toggle();
	else
		LGReceiver_SlashCmd("");
	end
end

function LGReceiver_SlashCmd(msg)
	local msg = msg:lower();
	if (msg == "" or msg == nil) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900Following commands for /lgr:");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900show - |cffffff00Shows the frame");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900hide - |cffffff00Hides the frame");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900toggle - |cffffff00Toggles the frame on/off");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900on - |cffffff00Activates the AddOn");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900off - |cffffff00Deactivates the AddOn");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900auto - |cffffff00Toggles the Autojoin on/off");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900max [number] - |cffffff00Sets the maximum for autojoin goldroll");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900reset - |cffffff00Resets the log files");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900unstuck - |cffffff00Resets the frame back in the window");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900button - |cffffff00Toggles the button on/off");
		DEFAULT_CHAT_FRAME:AddMessage("|cffff8900popup - |cffffff00Toggles the popups on/off");

	elseif (msg == "reset" or msg == "delete") then
		StaticPopupDialogs["RESET_LOGS"] = {
			text = "Do you really want to reset your logs?",
			button1 = "Yes",
			button2 = "No",
			OnAccept = function()
				LGReceiver_ResetLogs();
			end,
			timeout = 0,
			enterClicksFirstButton = true,
			whileDead = true,
			hideOnEscape = true,
			preferredIndex = 3,
			}
			StaticPopup_Show ("RESET_LOGS");

	elseif (msg == "unstuck") then
		LGReceiver_RevertPosition();

	elseif (msg == "popup" or msg == "popups") then
		LGReceiver_TogglePopups();

	elseif (msg == "button") then
		LGReceiver_ToggleButton();
	
	elseif (msg == "hide") then
		LGReceiver_Frame:Hide();
		LGReceiver["active"] = 0;
	
	elseif (msg == "show") then
		LGReceiver_Frame:Show();
		LGReceiver["active"] = 1;
	
	elseif (msg == "toggle") then
		LGReceiver_Toggle();
	
	elseif (msg == "update") then
		if(LGReceiver["working"] == 1) then
			LGReceiver_OnClickUPDATE();
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Activate [LGR] before updating");
		end	
	
	elseif (msg == "auto") then
		if(LGReceiver["working"] == 1) then
			LGReceiver_OnClickAUTOJOIN();
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Activate [LGR] before using Autojoin");
		end	
	
	elseif (string.sub(msg, 1, 3) =="max") then
		local buffer = string.sub(msg, 5);
		if(not tonumber(buffer)) then
			DEFAULT_CHAT_FRAME:AddMessage(string.format("|cff009EFFAutojoin max = '%s'", LGReceiver["max"]));
			return;
		end
		if(buffer == nil or buffer == -1 or buffer == "") then
			DEFAULT_CHAT_FRAME:AddMessage(string.format("|cff009EFFAutojoin max = '%s'", LGReceiver["max"]));
		else
			LGReceiver["max"] = math.abs(math.floor(buffer));
			DEFAULT_CHAT_FRAME:AddMessage(string.format("|cff009EFFAutojoin max = '%s'", LGReceiver["max"]));
		end
	
	elseif (msg == "active" or msg == "activate" or msg == "on") then
		LGReceiver["working"] = 1;
		LGReceiver_UPDATE_Button:Enable();
		LGReceiver_AUTOJOIN_Button:Enable();
		LGReceiver_ACTIVE_Button:SetText("Activated");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LGR] activated.");	
	
	elseif (msg == "deactive" or msg == "deactivate" or msg == "off") then
		LGReceiver["working"] = 0;
		LGReceiver_UPDATE_Button:Disable();
		LGReceiver_ROLL_Button:Disable();
		LGReceiver_ACTIVE_Button:SetText("Deactivated");
		LGReceiver_AUTOJOIN_Button:Disable();
		LGReceiver_AUTOJOIN_Button:SetText("Autojoin");
		autojoin = false;
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00[LGR] deactivated.");

	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Invalid argument for command /lgr");
	end
end

SLASH_LGReceiver1 = "/lgr";
SLASH_LGReceiver2 = "/lrg";
SLASH_LGReceiver3 = "/lr";
SlashCmdList["LGReceiver"] = LGReceiver_SlashCmd